#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require('commander');
var config_file_1 = require("./config-file");
var push_1 = require("./commands/push");
var merge_1 = require("./commands/merge");
var pull_1 = require("./commands/pull");
var status_1 = require("./commands/status");
var packageJson = require('../package.json');
program
    .version(packageJson.version);
program
    .command('status')
    .option('-f, --full', 'Include full hg status (slower)')
    .description('show status for all repos')
    .action(function () { return execCommand(status_1.status, { full: true || !!program.full }); }); // hardcode --full to true for now - it may soon be the default
program
    .command('pull')
    .description('hg pull on all repos')
    .action(function () { return execCommand(pull_1.pull); });
program
    .command('merge')
    .description('try merge all repos with latest default')
    .action(function () { return execCommand(merge_1.merge); });
program
    .command('push')
    .description('hg push on all repos')
    .action(function () { return execCommand(push_1.push); });
program
    .parse(process.argv);
if (!process.argv.slice(2).length) {
    execCommand(status_1.status, { full: !!program.full });
}
function execCommand(command, options) {
    if (options === void 0) { options = {}; }
    config_file_1.getConfig()
        .then(function (config) {
        command(config, options);
    })
        .catch(function (err) { return console.error(err); });
}
