"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Listr = require('listr');
require("rxjs/add/operator/do");
var Observable_1 = require("rxjs/Observable");
var hg_1 = require("../hg");
function status(config, options) {
    var projTasks = config.projects.map(function (project) {
        return {
            title: project.path,
            task: function (ctx, task) { return getProjectStatusTask(project, options, ctx, task); }
        };
    });
    var tasks = new Listr(projTasks, {
        concurrent: config.maxConcurrent || hg_1.MAX_CONCURRENT_HGS,
        exitOnError: false
    });
    return tasks.run();
}
exports.status = status;
function getProjectStatusTask(project, options, _, task) {
    return Observable_1.Observable.create(function (subscriber) {
        var branchName;
        hg_1.getBranch(project.path)
            .subscribe(function (data) {
            branchName = data;
            subscriber.next(data);
        }, function (err) { return subscriber.error(err); }, function () {
            task.title = project.path + " - " + branchName;
            if (options.full) {
                var status_1;
                hg_1.getStatus(project.path)
                    .subscribe(function (data) {
                    status_1 = data;
                    subscriber.next(status_1);
                }, function (err) { return subscriber.error(err); }, function () {
                    status_1 = (status_1 || '').trim();
                    var statusLines = status_1.split('\n');
                    if (statusLines.length) {
                        task.title = project.path + " - " + branchName + " (" + statusLines.length + ")";
                    }
                    subscriber.complete();
                });
            }
            else {
                subscriber.complete();
            }
        });
    });
}
